/*************************************************************************/
/*                                                                       */
/*   examinar.c                                                          */
/*   Rev. 30.0  1/03/2003   AUTOR: Emilio Molina Cazorla				 */
/*                                                                       */
/*************************************************************************/

/***************** INCLUDES DE LAS LIBRERIAS NECESARIAS ******************/

#include <gl\glaux.h>
#include <gl\glu.h>
#include <stdio.h>

void CALLBACK display (void);
void CALLBACK v0 (void);

/******************* DECLARACION DE VARIABLES GLOBALES *******************/

GLdouble  alfa = 0.0, beta = 0.0, gamma = 0.0, fovy= 60.0, aspect;
GLdouble cleft=-2.0, cright=2.0, cbottom=-2.0, ctop=2.0, cnear=0.00001, cfar=1000.0;
double u,v,factor=0.0,velx=0.0, vely=0.0, czoom=1.0, rot=0.0;
char O=1, T=1, C=1, I=1, D=1, solid=0, transparent=0; 
GLint xMouse, xMouse2, yMouse, yMouse2;
char vista=1,rota=0;

/************* ESTABLECE LA PROYECCION ***********************************/

void proyeccion (void) {

    /* Definicion del tipo de proyeccin */
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	gluPerspective(fovy, aspect, 1.0,400.0);
}

void proyeccion2(void) {

	/* Segundo tipo de proyeccin */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho (cleft*czoom*aspect, cright*czoom*aspect, cbottom*czoom, ctop*czoom, cnear, cfar);
}


/************* RUTINA DE SERVICIO DE LOS EVENTOS DE VENTANA **************/

void CALLBACK reshape (GLsizei w, GLsizei h)
{
	u=w;
	v=h;
    /* Definicion del viewport */
	glViewport(0,0,w,h);  
	aspect= (GLdouble)w/(GLdouble)h;
	
	/* actualiza la proyeccin */
	if(vista){
		proyeccion();}
	else { proyeccion2();}
}

/************ RUTINAS DE SERVICIO DE LOS EVENTOS DE TECLADO **************/

void CALLBACK up (void)
{
    beta = beta - 5.0;
    if (beta<0.0) beta = beta + 360.0;
}
void CALLBACK down (void)
{
    beta = beta + 5.0;
	if (beta > 360.0)  beta = beta - 360.0;
}
void CALLBACK right (void)
{
    alfa = alfa + 5.0;
    if (alfa>360.0) alfa = alfa - 360.0;
}
void CALLBACK left (void)
{
    alfa = alfa - 5.0;
    if (alfa<0.0) alfa = alfa + 360.0;
}
void CALLBACK incright (void)
{
    gamma = gamma + 5.0;
    if (gamma>360.0) gamma = gamma - 360.0;
}
void CALLBACK incleft (void)
{
    gamma = gamma - 5.0;
    if (gamma<0.0) gamma = gamma + 360.0;
}
void CALLBACK Zoom (void)
{	
	fovy=fovy-1.0;
	if (fovy< 1.0) fovy= 1.0;
	czoom=czoom-0.025;
	if (czoom<-0.475) czoom=-0.475;
	if (vista) {
		proyeccion();	/* actualiza la proyeccin */
	}
	else { proyeccion2();}

}
void CALLBACK zoom (void)
{
	fovy=fovy+1.0;
	if (fovy> 120.0) fovy= 120.0;
	czoom=czoom+0.025;
	if (czoom>2.5) czoom=2.5;
	if (vista) {
		proyeccion();	/* actualiza la proyeccin */
	}
	else { proyeccion2();}
}

void CALLBACK Faster(void)
{
	factor=factor+0.05;
}

void CALLBACK Slower(void)
{
	factor=factor-0.05;
}

void CALLBACK reset(void)
{
	alfa = 0.0;
	beta = 0.0;
	gamma= 0.0;
	fovy= 60.0;
	czoom= 1.0;
	factor=0.0;
	v0();
	if(vista) {
		proyeccion();}
	else {proyeccion2();}
	velx = 0;
	vely = 0;
}

void CALLBACK v1(void)
{
	if (O==1) {O=0;}
	else {O=1;}
}

void CALLBACK v2(void)
{
	if (T==1) {T=0;}
	else {T=1;}
}

void CALLBACK v3(void)
{
	if (C==1) {C=0;}
	else {C=1;}
}

void CALLBACK v5(void)
{
	if (I==1) {I=0;}
	else {I=1;}
}

void CALLBACK v4(void)
{
	if (D==1) {D=0;}
	else {D=1;}
}

void CALLBACK v0(void)
{
	O=1;
	T=1;
	C=1;
	I=1;
	D=1;
}

void CALLBACK stop(void)
{
	factor=0.0;
	velx=vely=0.0;
}

void CALLBACK solidificar(void)
{
	if (solid==0) {solid=1;}
	else {solid=0;}
}

void CALLBACK transparentificar(void)
{
	if (transparent==0) {transparent=1;}
	else {transparent=0;}
}

void CALLBACK cvista(void)
{
	if (vista==1) {vista=0; proyeccion2();}
	else {vista=1; proyeccion();}
}

void CALLBACK BotonIzqdo(AUX_EVENTREC *event)
{
	xMouse = event->data[AUX_MOUSEX];
	yMouse = 600 - event->data[AUX_MOUSEY];
	velx=0;
	vely=0;
	rota=0;
	factor=0.0;
}

void CALLBACK BotonDrcho(AUX_EVENTREC *event)
{
	stop();
}

void CALLBACK BotonIzqdo2(AUX_EVENTREC *event)
{
	xMouse2 = event->data[AUX_MOUSEX];
	yMouse2 = 600 - event->data[AUX_MOUSEY];
	velx = -(xMouse2 - xMouse);
	vely = -(yMouse2 - yMouse);
}

void CALLBACK BotonIzqdo3(AUX_EVENTREC *event)
{
	alfa = alfa+velx;
	beta = beta+vely;
	if(velx!=0||vely!=0) rota=1;
	else rota=0;
}

/* Rutina de definicin de eventos */
void events(void)
{
    auxKeyFunc(AUX_UP, up);
    auxKeyFunc(AUX_DOWN, down);
    auxKeyFunc(AUX_RIGHT, right);
    auxKeyFunc(AUX_LEFT, left);
	auxKeyFunc(AUX_q, incleft);
	auxKeyFunc(AUX_w, incright);
	auxKeyFunc(AUX_z, Zoom);
	auxKeyFunc(AUX_x, zoom);
	auxKeyFunc(AUX_a, Faster);
	auxKeyFunc(AUX_s, Slower);
	auxKeyFunc(AUX_SPACE, reset);
	auxKeyFunc(AUX_1, v1);
	auxKeyFunc(AUX_2, v2);
	auxKeyFunc(AUX_3, v3);
	auxKeyFunc(AUX_4, v4);
	auxKeyFunc(AUX_5, v5);
	auxKeyFunc(AUX_0, v0);
	auxKeyFunc(AUX_RETURN, stop);
	auxKeyFunc(AUX_p, solidificar);
	auxKeyFunc(AUX_o, transparentificar);
	auxKeyFunc(AUX_v, cvista);
	auxMouseFunc(AUX_LEFTBUTTON, AUX_MOUSEDOWN, BotonIzqdo);
	auxMouseFunc(AUX_RIGHTBUTTON, AUX_MOUSEDOWN, BotonDrcho);
	auxMouseFunc(AUX_LEFTBUTTON, AUX_MOUSELOC, BotonIzqdo2);
	auxMouseFunc(AUX_LEFTBUTTON, AUX_MOUSEUP, BotonIzqdo3);
    auxReshapeFunc(reshape);
	auxIdleFunc(display);
}


/************ RUTINAS DE DIBUJO **************/


/* Rutina de dibujo de la escena */
void CALLBACK display(void) {

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
 /* Transformacion de la camara */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslated(0.0,0.0,-3.5);
	if(rota){
	glRotatef(rot,0.0,1.0,0.0);
	beta=beta+vely*0.01;
	alfa=alfa+velx*0.01;
	glRotated (-gamma, 0.0,0.0,1.0);
	glRotated (beta, 1.0,0.0,0.0);
    glRotated (-alfa, 0.0,1.0,0.0);
	}
	else {
	glRotatef(rot,0.0,1.0,0.0);
	glRotated (-gamma, 0.0,0.0,1.0);
	glRotated (beta+vely, 1.0,0.0,0.0);
    glRotated (-alfa-velx, 0.0,1.0,0.0);
	}
	/* Dibujar objetos */

	escena(O, T, C, I, D, solid, transparent);
	rot=rot+factor;
	if (rot==360) {rot=rot-360;}
	if (rot==-360) {rot=rot+360;}
	/* Luces */
	
	{
		GLfloat light_ambient []  = { 0.2, 0.2, 0.2, 1.0 };
		GLfloat light_diffuse []  = { 1.0, 1.0, 1.0, 1.0 };
		GLfloat light_specular [] = { 0.2, 0.2, 0.2, 1.0 };
	//	GLfloat light_position [] = { 0.0, 0.0, -2.0, 0.0 };

		glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
		glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
		glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);
	//	glLightfv(GL_LIGHT0, GL_POSITION, light_position);

 	glEnable(GL_LIGHT0);
	}

	
	/* Dibujar Objetos */
//	escenaIluminacion();

	glFlush();
	auxSwapBuffers();

}

/* Llamada a la funcion de inicializacin */
void init (void) {

	glClearColor (0.0f, 0.0f, 0.0f, 0.0f);
	glColor3f (1.0f, 1.0f, 1.0f);
	glDepthFunc(GL_LEQUAL);
    glEnable(GL_DEPTH_TEST);
	glEnable(GL_CULL_FACE);  // si hace cosas raras, deshabilitar esta lnea
	glCullFace(GL_BACK);
	glColorMaterial(GL_FRONT_AND_BACK,GL_DIFFUSE); //Inicializamos el material
	glEnable(GL_COLOR_MATERIAL);				   //
	{											   //Inicializamos la iluminacin
		GLfloat lmodel_ambient [] = {0.2,0.2,0.2,1.0}; 

		/* Parmetros del modelo de iluminacin */

		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
		glLightModelf(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
		glFrontFace(GL_CCW);

		/* Activa la iluminacin de la escena */

		glEnable(GL_LIGHTING);	
		glEnable(GL_NORMALIZE);
	}
}


/* Creacin de la ventana */
void abreVentana (void) {

	auxInitDisplayMode(AUX_DOUBLE | AUX_RGBA | AUX_DEPTH);
	auxInitPosition(0, 0, 500, 500);
	auxInitWindow("Omnipoliedro v4.0. Consulte el archivo leme.txt");
}


/* Programa principal */
void main(void) {
	/* Creacin de la ventana de la aplicacin */
	abreVentana ();

	/* Imprimimos los datos de los poliedros */

	printf("\n\n\t\tDatos del omnipoliedro:\n\n");
	printf("\n\t\tPoliedro \tV%crtices Aristas Caras\n",130);
	printf("\t\t--------------------------------------\n");
	printf("\n\t\tOctaedro \t6\t 12\t 8\n");
	printf("\n\t\tTetraedro\t4\t 6\t 4\n");
	printf("\n\t\tCubo\t\t8\t 12\t 6\n");
	printf("\n\t\tIcosaedro\t12\t 30\t 20\n");
	printf("\n\t\tDodecaedro\t20\t 30\t 12\n");
	printf("\n\nPara saber m%cs, visite http://teleline.terra.es/personal/joseantm/\n\n",160);

	/* Llamada a la funcin de inicializacin */
	init ();

	/* Rutinas para el control de eventos */
    events();
	
	/* A la espera de eventos.... */
	auxMainLoop(display);
}

