/*************************************************************************/
/*                                                                       */
/*         Modelado.c Librera de modelado del omnipoliedro	             */
/*                                                                       */
/*   Rev. 30.0  1/03/2003   AUTOR: Emilio Molina Cazorla				 */
/*                                                                       */
/*************************************************************************/

/***************** INCLUDES DE LAS LIBRERIAS NECESARIAS ******************/

#include <gl/glaux.h>
#include <math.h>
#include "Modelado.h"
#define  grad2rad(x)  ((float) (3.14159 * x) / 180.0)

/************************* FUNCIONES BASICAS *****************************/

void escena(char O, char T, char C, char I, char D, char solid, char transparent) {
	glLineWidth (2.0);
	if (solid) {glEnable(GL_LIGHTING);}
	else {glDisable(GL_LIGHTING);}
	if(solid){
		Omnisolid(O,T,C,I,D);
		if(transparent){Omniwire(O,T,C,I,D);}
	}
	else{
		Omniwire(O,T,C,I,D);
	}
}

void Omnisolid(char O, char T, char C, char I, char D){
glPushMatrix();
glScalef(0.7,0.7,0.7);
		if (O) {
				glColor3f(1.0,1.0,0.0);
				auxSolidOctahedron(0.99);
		}
		if (T) {
				glColor3f(1.0,0.0,0.0);
				auxSolidTetrahedron (1.73);
		}
		if (C) {
				glColor3f(0.0,1.0,0.0);
				auxSolidCube (2);
		}
		if (I) {
				glColor3f(0.0,0.0,1.0);
			auxSolidIcosahedron (1.9);
		}
		if (D) {
				glPushMatrix();
				glColor3f(1.0,0.0,1.0);
				glRotatef(90,0.0,1.0,0.0);
				auxSolidDodecahedron (1.73);
				glPopMatrix();
		}
glPopMatrix();
}

void Omniwire(char O, char T, char C, char I, char D){
glPushMatrix();
glScalef(0.7,0.7,0.7);
glDisable(GL_DEPTH_TEST);
		if (O) {
		glColor3f(1.0,1.0,0.0);
		auxWireOctahedron (0.99);
		}
		if (T) {
		glColor3f(1.0,0.0,0.0);
		auxWireTetrahedron (1.73);
		}
		if (C) {
		glColor3f(0.0,1.0,0.0);
		auxWireCube (2);
		}
		if (I) {
		glColor3f(0.0,0.0,1.0);
		auxWireIcosahedron (1.9);
		}
		if (D) {
		glPushMatrix();
		glColor3f(1.0,0.0,1.0);
		glRotatef(90,0.0,1.0,0.0);
		auxWireDodecahedron (1.73);
		glPopMatrix();
		}
glEnable(GL_DEPTH_TEST);
glPopMatrix();
}